'Auswerteprogramm fr einen Geigerzhler
'Version 03a
'Induktivitt 10 mH/5%
$regfile = "m8def.dat"
$crystal = 8000000

Dim Preload0 As Byte ' Der Preloadwert fr Timer 0
Dim Preload1 As Word ' Der Preloadwert fr Timer 1
Dim Flag as Byte  'Wird auf 1 gesetzt wenn ein Impuls empfangen wurde
Dim Flag1 as Byte 'Wird auf 1 gesetzt wenn 1 Sekunde verstrichen ist
Dim Zeit60 as Byte 'Zeitzhler von von 0 bis 60 Sekunden
Dim Zeit10 as Byte 'Zeitzhler von von 0 bis 10 Sekunden
Dim LCnt60 as Long 'Letzter Zhlerstand nach 60 Sekunden
Dim LCnt10 as Long 'Letzter Zhlerstand nach 10 Sekunden
Dim CpM60 As Word  'Impuse/ Minute nach 60 Sekunden (Counts per Minit)
Dim CpM10 As Word  'Impuse/ Minute nach 10 Sekunden, interpoliert (Counts per Minit)
Dim Gesamtzaehler as Long 'Anzahl der Impulse, die seit Beginn der Zhlung empfangen wurden
Dim ImpVerl as Word 'Impulsverlngerung fr die Tonausgabe
Dim Raw as Word 'Zhler des Analogwertes der Spannungsmessung (von 0 bis 1023)
const Ref=15.889/1023 'Umrechnungsfaktor von RAW in Volt
Dim Volt as Single 'gemessene Spannung in Volt

'Ton
Ton Alias PortB.1
Config Ton = Output
'LED
LED Alias PortD.0
Config LED = Output
'Takt
Takt Alias PortD.1
Config Takt = Output
'Zhlereingang Int0, PD2
Zaehleingang Alias Pind.3
Config Zaehleingang = Input

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

on Int1 Zaehler
Config Int1 = Falling
Enable Int1

On Timer0 Zeitroutine0
Config Timer0 = Timer , Prescale = 8
Preload0 = &HCE 'ca. 10kHz
Timer0 = Preload0
Enable Timer0

On Timer1 Zeitroutine1
Config Timer1 = Timer , Prescale = 1024
Preload1 = 57724 ' ca. 1Sekunde
Timer1 = Preload1
Enable Timer1
Enable Interrupts


Config Lcdbus = 4
Config Lcd = 16 * 2
'Lcdpin = Pin,Db4=PortD.5,Db5=PortD.6,Db6=PortD.7,Db7=PortB.0,
'E=PortD.4,Rs=PortD.2 (Nur damit es aufs Papier passt)
Config Lcdpin = Pin , Db4 = PortD.5 , Db5 = PortD.6 , Db6 = PortD.7 , Db7 = PortB.0, E = PortD.4 , Rs = PortD.2
CLS
Cursor off

Flag = 0
Flag1 = 0
RAW=getadc(5)
Volt=RAW*Ref

Do
      if Flag=1 then
         ' Impuls empfangen
         Flag=0
         Set Ton'Ton
         Set LED'LED
      end If

      if Flag1=1 then
         '1 Sekunde verstrichen
         Flag1=0
         Reset LED
         incr Zeit60
         incr Zeit10

         if Zeit60>59 then
            'Jede Minute
            Zeit60=0
            CpM60=Gesamtzaehler-LCnt60
            Lcnt60=Gesamtzaehler
            RAW=getadc(5)
            Volt=RAW*Ref
         end if

         if Zeit10>9 then
            'Alle 10 Sekunden
            Zeit10=0
            CpM10=Gesamtzaehler-LCnt10
            CpM10=CpM10*6
            Lcnt10=Gesamtzaehler
         end if

         Locate 1,1
         LCD "CpM:            " 'letzte Anzeige lschen
         Locate 1,1
         LCD "CpM: ";CpM10;"/";CpM60
         Locate 2,1
         LCD "Tot:            " 'letzte Anzeige lschen
         Locate 2,1
         LCD "Tot: ";Gesamtzaehler
         Locate 2,12
         LCD Fusing(Volt,"#.#");"V"
      end If
       if Ton=1 then
         incr ImpVerl
         if ImpVerl =100 then
            '100 Durchlufe bis der Ton abgeschaltet wird
            ' so wird der kurze Impuls hrbar
            ImpVerl=0
            Ton = 0
         end if
       end if
Loop
End

Zaehler:
   'Es wurde ein Impuls vom Zhlrohr empfangen
   Incr Gesamtzaehler
   Flag=1
Return

Zeitroutine0:
    Timer0 = Preload0
    '10000Hz-Signal fr den Spannungswandler erzeugen:
    Toggle Takt
Return

Zeitroutine1:
   'Sekundentimer (Eine Sekunde ist um)
   Timer1 =Preload1
   Flag1=1
Return
End